#include "stdafx.h"

#include "include/lexertl/debug.hpp"
#include "include/lexertl/generator.hpp"

int main()
{
	try
	{
		lexertl::rules rules_;
		lexertl::state_machine sm_;

		rules_.insert_macro("AllValid", "[\\x1-\\xff]");
		rules_.insert_macro("ControlCodes", "[\\0-\\x1f\\x7f-\\x9f]");
		rules_.insert_macro("AnyCh", "{AllValid}{-}{ControlCodes}");
		rules_.push("{AnyCh}+", 123);

		lexertl::generator::build(rules_, sm_);
		lexertl::debug::dump(sm_, std::cout);
	}
	catch (const std::exception &e)
	{
		std::cout << e.what() << '\n';
	}

	return 0;
}
